package model {

import mx.collections.ArrayCollection;
import model.Product;
import flash.events.Event;

public class ShoppingCart {

	[Bindable]
    public var items:ArrayCollection;
    
 	[Bindable]   
    public var total:Number = 0;
    
 	[Bindable]     
    public var shippingCost: Number;

    public function ShoppingCart() {
        items=new ArrayCollection();
    }

    public function addItem(product:Product, quantity:Number):void 
    {
    	if (quantity <= 0) {
    		quantity = 1;
    	}
    	//
    	var len:int = items.length;
    	for (var i:int = 0; i < len; i++) {
    		if (items[i].product == product) {
    			var currentItem:Object = items[i];
    			currentItem.quantity += quantity;
    			total += product.price*quantity;
    			// notify the update for the views (datagrid) 
    			items.itemUpdated(currentItem);
    			return;
    		}
    	}
    	// Add new Item
    	var itemAdded:Object = new Object();
    	itemAdded.product = product;
    	itemAdded.name = product.name;
    	itemAdded.price = product.price;
    	itemAdded.quantity = quantity;
    	items.addItem(itemAdded);
    	
    	total += itemAdded.price*quantity;
    }
 
 	public function removeItemAt(index:Number):void {
 		var currentItem:Object = items[index];
   		total -= currentItem.price*currentItem.quantity;
        items.removeItemAt(index);
	   	if (getItemCount() == 0){
			shippingCost = 0;
	   	}
    }

    public function getItemCount(): Number {
        return items.length;
    }

    public function getTotal(): Number {
        return total;
    }

}

}